Loading...
Searching...
No Matches
IP address/port utilities.

## Files

file | sockaddr_str.h
| Common API to store an IP address and port.

## Data Structures

struct | osmo_sockaddr_str

## Macros

#define | OSMO_SOCKADDR_STR_FMT "%s%s%s:%u"
| Format string to print an osmo_sockaddr_str.
#define | OSMO_SOCKADDR_STR_FMT_ARGS_NOT_NULL(R)
#define | OSMO_SOCKADDR_STR_FMT_ARGS(R)

## Functions

int | osmo_ip_str_type (const char *ip)
bool | osmo_sockaddr_str_is_set (const struct osmo_sockaddr_str *sockaddr_str)
bool | osmo_sockaddr_str_is_nonzero (const struct osmo_sockaddr_str *sockaddr_str)
int | osmo_sockaddr_str_cmp (const struct osmo_sockaddr_str *a, const struct osmo_sockaddr_str *b)
int | osmo_sockaddr_str_from_str (struct osmo_sockaddr_str *sockaddr_str, const char *ip, uint16_t port)
int | osmo_sockaddr_str_from_str2 (struct osmo_sockaddr_str *sockaddr_str, const char *ip)
int | osmo_sockaddr_str_from_in_addr (struct osmo_sockaddr_str *sockaddr_str, const struct in_addr *addr, uint16_t port)
int | osmo_sockaddr_str_from_in6_addr (struct osmo_sockaddr_str *sockaddr_str, const struct in6_addr *addr, uint16_t port)
int | osmo_sockaddr_str_from_32 (struct osmo_sockaddr_str *sockaddr_str, uint32_t ip, uint16_t port)
int | osmo_sockaddr_str_from_32h (struct osmo_sockaddr_str *sockaddr_str, uint32_t ip, uint16_t port)
int | osmo_sockaddr_str_from_sockaddr_in (struct osmo_sockaddr_str *sockaddr_str, const struct sockaddr_in *src)
int | osmo_sockaddr_str_from_sockaddr_in6 (struct osmo_sockaddr_str *sockaddr_str, const struct sockaddr_in6 *src)
int | osmo_sockaddr_str_from_sockaddr (struct osmo_sockaddr_str *sockaddr_str, const struct sockaddr_storage *src)
int | osmo_sockaddr_str_from_osa (struct osmo_sockaddr_str *sockaddr_str, const struct osmo_sockaddr *src)
int | osmo_sockaddr_str_to_in_addr (const struct osmo_sockaddr_str *sockaddr_str, struct in_addr *dst)
int | osmo_sockaddr_str_to_in6_addr (const struct osmo_sockaddr_str *sockaddr_str, struct in6_addr *dst)
int | osmo_sockaddr_str_to_32 (const struct osmo_sockaddr_str *sockaddr_str, uint32_t *ip)
int | osmo_sockaddr_str_to_32h (const struct osmo_sockaddr_str *sockaddr_str, uint32_t *ip)
int | osmo_sockaddr_str_to_sockaddr_in (const struct osmo_sockaddr_str *sockaddr_str, struct sockaddr_in *dst)
int | osmo_sockaddr_str_to_sockaddr_in6 (const struct osmo_sockaddr_str *sockaddr_str, struct sockaddr_in6 *dst)
int | osmo_sockaddr_str_to_sockaddr (const struct osmo_sockaddr_str *sockaddr_str, struct sockaddr_storage *dst)
int | osmo_sockaddr_str_to_osa (const struct osmo_sockaddr_str *sockaddr_str, struct osmo_sockaddr *dst)
int | osmo_sockaddr_str_from_32n (struct osmo_sockaddr_str *sockaddr_str, uint32_t ip, uint16_t port) OSMO_DEPRECATED("osmo_sockaddr_str_from_32n() actually uses *host* byte order. Use osmo_sockaddr_str_from_32h() instead")
int | osmo_sockaddr_str_to_32n (const struct osmo_sockaddr_str *sockaddr_str, uint32_t *ip) OSMO_DEPRECATED("osmo_sockaddr_str_to_32n() actually uses *host* byte order. Use osmo_sockaddr_str_to_32h() instead")

## Detailed Description

## Macro Definition Documentation

## OSMO_SOCKADDR_STR_FMT

#define OSMO_SOCKADDR_STR_FMT "%s%s%s:%u"

Format string to print an osmo_sockaddr_str.

For example:

    struct osmo_sockaddr_str *my_sockaddr_str = ...;
    printf("got " OSMO_SOCKADDR_STR_FMT "\n", OSMO_SOCKADDR_STR_FMT_ARGS(my_sockaddr_str));

## OSMO_SOCKADDR_STR_FMT_ARGS

#define OSMO_SOCKADDR_STR_FMT_ARGS | ( |  | R | ) |

Value:
((R) && (R)->af == AF_INET6) ? "[" : "", \
(R) ? (R)->ip : "NULL", \
((R) && (R)->af == AF_INET6) ? "]" : "", \
(R) ? (R)->port : 0
R
#define R(x, n)

## OSMO_SOCKADDR_STR_FMT_ARGS_NOT_NULL

#define OSMO_SOCKADDR_STR_FMT_ARGS_NOT_NULL | ( |  | R | ) |

Value:
((R)->af == AF_INET6) ? "[" : "", \
(R)->ip, \
((R)->af == AF_INET6) ? "]" : "", \
(R)->port

## Function Documentation

## osmo_ip_str_type()

int osmo_ip_str_type | ( | const char * | ip | ) |

## osmo_sockaddr_str_cmp()

int osmo_sockaddr_str_cmp | ( | const struct osmo_sockaddr_str * | a,
|  | const struct osmo_sockaddr_str * | b )

## osmo_sockaddr_str_from_32()

int osmo_sockaddr_str_from_32 | ( | struct osmo_sockaddr_str * | sockaddr_str,
|  | uint32_t | ip,
|  | uint16_t | port )

## osmo_sockaddr_str_from_32h()

int osmo_sockaddr_str_from_32h | ( | struct osmo_sockaddr_str * | sockaddr_str,
|  | uint32_t | ip,
|  | uint16_t | port )

## osmo_sockaddr_str_from_32n()

int osmo_sockaddr_str_from_32n | ( | struct osmo_sockaddr_str * | sockaddr_str,
|  | uint32_t | ip,
|  | uint16_t | port )

## osmo_sockaddr_str_from_in6_addr()

int osmo_sockaddr_str_from_in6_addr | ( | struct osmo_sockaddr_str * | sockaddr_str,
|  | const struct in6_addr * | addr,
|  | uint16_t | port )

## osmo_sockaddr_str_from_in_addr()

int osmo_sockaddr_str_from_in_addr | ( | struct osmo_sockaddr_str * | sockaddr_str,
|  | const struct in_addr * | addr,
|  | uint16_t | port )

## osmo_sockaddr_str_from_osa()

int osmo_sockaddr_str_from_osa | ( | struct osmo_sockaddr_str * | sockaddr_str,
|  | const struct osmo_sockaddr * | src )

## osmo_sockaddr_str_from_sockaddr()

int osmo_sockaddr_str_from_sockaddr | ( | struct osmo_sockaddr_str * | sockaddr_str,
|  | const struct sockaddr_storage * | src )

## osmo_sockaddr_str_from_sockaddr_in()

int osmo_sockaddr_str_from_sockaddr_in | ( | struct osmo_sockaddr_str * | sockaddr_str,
|  | const struct sockaddr_in * | src )

## osmo_sockaddr_str_from_sockaddr_in6()

int osmo_sockaddr_str_from_sockaddr_in6 | ( | struct osmo_sockaddr_str * | sockaddr_str,
|  | const struct sockaddr_in6 * | src )

## osmo_sockaddr_str_from_str()

int osmo_sockaddr_str_from_str | ( | struct osmo_sockaddr_str * | sockaddr_str,
|  | const char * | ip,
|  | uint16_t | port )

## osmo_sockaddr_str_from_str2()

int osmo_sockaddr_str_from_str2 | ( | struct osmo_sockaddr_str * | sockaddr_str,
|  | const char * | ip )

## osmo_sockaddr_str_is_nonzero()

bool osmo_sockaddr_str_is_nonzero | ( | const struct osmo_sockaddr_str * | sockaddr_str | ) |

## osmo_sockaddr_str_is_set()

bool osmo_sockaddr_str_is_set | ( | const struct osmo_sockaddr_str * | sockaddr_str | ) |

## osmo_sockaddr_str_to_32()

int osmo_sockaddr_str_to_32 | ( | const struct osmo_sockaddr_str * | sockaddr_str,
|  | uint32_t * | ip )

## osmo_sockaddr_str_to_32h()

int osmo_sockaddr_str_to_32h | ( | const struct osmo_sockaddr_str * | sockaddr_str,
|  | uint32_t * | ip )

## osmo_sockaddr_str_to_32n()

int osmo_sockaddr_str_to_32n | ( | const struct osmo_sockaddr_str * | sockaddr_str,
|  | uint32_t * | ip )

## osmo_sockaddr_str_to_in6_addr()

int osmo_sockaddr_str_to_in6_addr | ( | const struct osmo_sockaddr_str * | sockaddr_str,
|  | struct in6_addr * | dst )

## osmo_sockaddr_str_to_in_addr()

int osmo_sockaddr_str_to_in_addr | ( | const struct osmo_sockaddr_str * | sockaddr_str,
|  | struct in_addr * | dst )

## osmo_sockaddr_str_to_osa()

int osmo_sockaddr_str_to_osa | ( | const struct osmo_sockaddr_str * | sockaddr_str,
|  | struct osmo_sockaddr * | dst )

## osmo_sockaddr_str_to_sockaddr()

int osmo_sockaddr_str_to_sockaddr | ( | const struct osmo_sockaddr_str * | sockaddr_str,
|  | struct sockaddr_storage * | dst )

## osmo_sockaddr_str_to_sockaddr_in()

int osmo_sockaddr_str_to_sockaddr_in | ( | const struct osmo_sockaddr_str * | sockaddr_str,
|  | struct sockaddr_in * | dst )

## osmo_sockaddr_str_to_sockaddr_in6()

int osmo_sockaddr_str_to_sockaddr_in6 | ( | const struct osmo_sockaddr_str * | sockaddr_str,
|  | struct sockaddr_in6 * | dst )